// Gmail Manager
// By Todd Long <longfocus@gmail.com>
// http://www.longfocus.com/firefox/gmanager/

var GM_gImports = {
  _accounts: null,
  _visible: false,
  
  load: function()
  {
    var passEnum = GM_CC["@mozilla.org/passwordmanager;1"].getService(GM_CI.nsIPasswordManager).enumerator;
    var importsList = GM_getEBI("gm-imports-list");
    
    // Accounts list
    this._accounts = new Array();
    
    while (passEnum.hasMoreElements())
    {
      var nextPass = passEnum.getNext().QueryInterface(GM_CI.nsIPassword);
      
      if (nextPass.host == "chrome://gm-notifier/")
      {
        var account = new Object();
        
        // Create account
        account.email = nextPass.user;
        account.password = nextPass.password;
        account.checked = true;
        
        if (account.email.indexOf("@") == -1)
          account.email += "@gmail.com";
        
        // Store account
        this._accounts[account.email] = account;
        
        // Append account to list
        importsList.appendChild(this._createListItem(account.email, account.password));
      }
    }
    
    if (!importsList.hasChildNodes())
      this.cancel();
  },
  
  _createListItem: function(aEmail, aPassword)
  {
    var listItem = document.createElement("listitem");
    
    listItem.setAttribute("allowevents", "true");
    
    var listCell = document.createElement("listcell");
    var listCheckbox = document.createElement("checkbox");
    
    listCheckbox.setAttribute("label", aEmail);
    listCheckbox.setAttribute("checked", true);
    listCheckbox.setAttribute("oncommand", "GM_gImports.markChecked(this);");
    
    listCell.appendChild(listCheckbox);
    listItem.appendChild(listCell);
    
    var listCell = document.createElement("listcell");
    var listLabel = document.createElement("label");
    
    listLabel.setAttribute("id", aPassword);
    listLabel.setAttribute("value", aPassword);
    listLabel.setAttribute("hidden", true);
    
    listCell.appendChild(listLabel);
    listItem.appendChild(listCell);
    
    return listItem;
  },
  
  markChecked: function(aCheckbox)
  {
    this._accounts[aCheckbox.label].checked = aCheckbox.checked;
  },
  
  togglePasswords: function()
  {
    this._visible = !this._visible;
    
    for (var account in this._accounts)
    {
      var e = GM_getEBI(this._accounts[account].password);
      e.hidden = !e.hidden;
    }
    
    GM_getEBI("gm-imports-show-passwords").label = (this._visible ? GM_getBundleString("imports-hide-passwords") : GM_getBundleString("imports-show-passwords"));
  },
  
  accept: function()
  {
    var observer = GM_CC["@mozilla.org/observer-service;1"].getService(GM_CI.nsIObserverService);
    var success = false;
    
    for (var account in this._accounts)
    {
      if (this._accounts[account].checked)
      {
        var type = "gmail";
        var email = this._accounts[account].email;
        var password = this._accounts[account].password;
        
        // Adds the account
        GM_getManager().addAccount("gmail", email, password, true, email);
      }
    }
    
    // Notify account changes
    observer.notifyObservers(null, GM_NOTIFY_ACCOUNT_CHANGE, "migrate");
    
    // Login all accounts
    if (GM_getEBI("gm-imports-login").checked)
      observer.notifyObservers(null, GM_NOTIFY_ACCOUNT_LOGIN, null);
    
    // Close window
    this.cancel();
  },
  
  cancel: function()
  {
    // Closes window
    self.close();
  }
}